osl::rating::Feature Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
osl::rating::Feature Class Referenceabstract

`#include <feature.h>`

Inheritance diagram for osl::rating::Feature:
[legend]

## Public Member Functions
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | match (const NumEffectState &state, Move, const RatingEnv &) const =0
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Private Attributes
std::string | my_name

## Detailed Description

Definition at line 17 of file rating/feature.h.

## Constructor & Destructor Documentation

osl::rating::Feature::Feature | ( | const std::string & | name) |  |
| inline

Definition at line 21 of file rating/feature.h.

osl::rating::Feature::~Feature | ( | ) |  |
| virtual

Definition at line 7 of file rating/feature.cc.

## Member Function Documentation

virtual bool osl::rating::Feature::effectiveInCheck | ( | ) |  | const
| inlinevirtual

Reimplemented in osl::rating::ImmediateAddSupport, osl::rating::Open, osl::rating::Block, osl::rating::KingEscape, osl::rating::Check, osl::rating::TakeBack2, and osl::rating::TakeBack.

Definition at line 26 of file rating/feature.h.

virtual bool osl::rating::Feature::match | ( | const NumEffectState & | state,
|  | Move | ,
|  | const RatingEnv & |
| ) |  | const
| pure virtual

Implemented in osl::rating::PawnAttack, osl::rating::BadLance, osl::rating::RookDefense, osl::rating::ImmediateAddSupport, osl::rating::PatternBlock, osl::rating::PatternLong2, osl::rating::SquareY, osl::rating::Chase, osl::rating::PatternLong, osl::rating::SquareX, osl::rating::Open, osl::rating::DefenseKing8, osl::rating::RelativeKingY, osl::rating::Block, osl::rating::KingEscape, osl::rating::SendOff, osl::rating::EscapePin, osl::rating::DropCaptured, osl::rating::Check, osl::rating::BigramAttack, osl::rating::RelativeKingX, osl::rating::ContinueCapture, osl::rating::ImmediateEscape, osl::rating::ShadowEffect2, osl::rating::TakeBack2, osl::rating::ToSupported, osl::rating::Pattern, osl::rating::ShadowEffect1, osl::rating::TakeBack, osl::rating::PtypeAttacked, osl::rating::Threatmate, osl::rating::PinAttack, osl::rating::Capture, osl::rating::Karanari, osl::rating::AttackKing8, osl::rating::FromEffect, and osl::rating::CheckmateIfCapture.

const std::string& osl::rating::Feature::name | ( | ) |  | const
| inline

Definition at line 27 of file rating/feature.h.

References my_name.

## Member Data Documentation

std::string osl::rating::Feature::my_name
| private

Definition at line 19 of file rating/feature.h.

Referenced by name().

The documentation for this class was generated from the following files:

- rating/feature.h
- rating/feature.cc